main(argc, argv)
	char	*argv[];
{
	register int nforks, i;
	char *cp;
	int pid,child,status,size;

	if (argc < 2){
		printf("usage : %s number-of-forks malloc-size \n", argv[0]);
		exit(1);
	}
	nforks = atoi(argv[1]);
	if (nforks < 0 ){
		printf("%s: bad number of forks \n", argv[1]);
		exit(2);
	}
	size = atoi(argv[2]);
	if (size < 0 ){
		printf("%s: bad size to malloc \n", argv[2]);
		exit(3);
	}
	cp = (char *) malloc(size);
	if((int)cp == -1){
		perror("malloc");
		exit(4);
	}
	for (i = 0; i < size; i += 1024)
		cp[i] = i;
	while (nforks-- > 0){
		child = fork();
		if (child == -1){
			perror("fork");
			exit(-1);
		}
		if (child == 0)
			exit(-1);
		while((pid = wait(&status)) != -1 && pid != child)
				;
	}
	exit(0);
}

