/* iorandom.c
/* Copyright (c) 1990, Prime Computer, Inc., Natick, MA 01760
/*                     All Rights Reserved
*/

/* Random number module for IOBENCH.

   random() delivers the next number from the table of COUNT random
   numbers defined in "ionumbers.h"

   setrandom(n) skips the next "n" numbers

   Initial Version: 10 June 1990 by Barry Wolman

*/

#include "ionumbers.h"

int pos = 0;

float random()
	{
	if (pos >= COUNT) pos = 0;
	return(table[pos++]);
	}

void setrandom (n)
int n;
	{
	pos += n;
	}
