#include <sys/types.h>
#include <sys/times.h>

#ifdef VMUNIX /* BSD only */

#include <sys/time.h>
struct timeval ts;
struct timezone tz;
int rtmsec()	/*  Real time in milliseconds.  (BSD) */
{
	static long epoch;
	gettimeofday(&ts, &tz);
	epoch = (ts.tv_sec * 1000) + (ts.tv_usec / 1000);
	return (epoch);
}

#else /* SYS5 */

struct	tms ts;
int rtmsec()	/*  Real time in milliseconds.  (System III)*/
{
	static long epoch;
	epoch = times(&ts);
	return (1000*epoch / HZ );
}
#endif
